<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2011 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

//Klasse zum Versenden von Attachments
//Gefunden unter http://www.phpwizard.net/resources/phpMisc/scripts/pretty/mail.php3
class mime_mail {
	var $parts;
	var $to;
	var $from;
	var $headers;
	var $subject;
	var $body;



	function mime_mail() {
		$this->parts = array();
		$this->to =  '';
		$this->from =  '';
		$this->subject =  '';
		$this->body =  '';
		$this->headers =  '';
	}//mime_mail()



	function add_attachment($message, $name =  '', $ctype =  'application/octet-stream') {
		$this->parts[] = array (
			'ctype' => $ctype,
			'message' => $message,
			'encode' => $encode,
			'name' => $name
		);
	}//add_attachment()



	function build_message($part) {
		$message = $part['message'];
		$message = chunk_split(base64_encode($message));
		$encoding =  'base64';
		return  'Content-Type: '.$part['ctype'].
			($part['name'] ? '; name = "'.$part['name']. '"' :  '').
			"\nContent-Transfer-Encoding: $encoding\n\n$message\n";
	}//build_message()



	function build_multipart() {
		$boundary =  'b'.md5(uniqid(time()));
		$multipart =  "Content-Type: multipart/mixed;boundary=$boundary\n\nThis is a MIME encoded message.\n\n--$boundary";

		for($i = sizeof($this->parts)-1; $i >= 0; $i--) {
			$multipart .=  "\n".$this->build_message($this->parts[$i]). '--'.$boundary;
		}
		return $multipart.=  "--\n";
	}//build_multipart()



	function send() {
		if(defined('ALLOW_SEND_EMAIL') && ALLOW_SEND_EMAIL == FALSE) return FALSE;

		$mime =  '';
		if (!empty($this->from))
			$mime .=  'From: '.$this->from. "\n";
		if (!empty($this->headers))
			$mime .= $this->headers. "\n";

		if (!empty($this->body))
			$this->add_attachment($this->body, '', 'text/plain');
		$mime .=  "MIME-Version: 1.0\n".$this->build_multipart();
		$return_path = defined('EMAIL_SET_RETURN_PATH') && EMAIL_SET_RETURN_PATH == TRUE ? '-f'.ko_get_setting('info_email') : '';

		//Output message if debugging is active
		if(defined('DEBUG_EMAIL') && DEBUG_EMAIL) {
			print '<h2>Email sent</h2>';
			foreach($this->headers as $h) {
				print ko_html($h).'<br />';
			}
			print '<b>To: '.ko_html($this->to).'</b><br />';
			print '<b>Subject: '.ko_html($this->subject).'</b><br />';
			print '<hr>'.nl2br($this->body).'<hr>';
			foreach($this->parts as $part) {
				if($part['ctype'] == 'text/plain') continue;
				if(substr($part['name'], -4) == '.xls') $path = '../download/excel/';
				else if(substr($part['name'], -4) == '.pdf') $path = '../download/pdf/';
				if(file_exists($path.$part['name'])) {
					print '<b>File: </b><a href="'.$path.$part['name'].'">'.$part['name'].'</a><br />';
				}
			}
			return TRUE;
		}
		
		//Send email for real
		else {
			if(mail($this->to, $this->subject,  '', $mime, $return_path))
				return TRUE;
			else
				return FALSE;
		}
	}//send()

};//class mime_mail
?>
